// ignore_for_file: public_member_api_docs, non_constant_identifier_names

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:equatable/equatable.dart';

part 'channels.g.dart';

@CopyWith()
class Channels extends Equatable {
  const Channels({
    required this.l1,
    required this.l2,
    required this.l3,
    required this.aVR,
    required this.aVL,
    required this.aVF,
    required this.v1,
    required this.v2,
    required this.v3,
    required this.v4,
    required this.v5,
    required this.v6,
  });

  Channels.fromList(List<List<double>> list)
      : assert(list.length == 12, ''),
        l1 = list[0],
        l2 = list[1],
        l3 = list[2],
        aVR = list[3],
        aVL = list[4],
        aVF = list[5],
        v1 = list[6],
        v2 = list[7],
        v3 = list[8],
        v4 = list[9],
        v5 = list[10],
        v6 = list[11];

  final List<double> l1;
  final List<double> l2;
  final List<double> l3;

  final List<double> aVR;
  final List<double> aVL;
  final List<double> aVF;

  final List<double> v1;
  final List<double> v2;
  final List<double> v3;
  final List<double> v4;
  final List<double> v5;
  final List<double> v6;

  List<List<double>> toList() => [
        l1,
        l2,
        l3,
        aVR,
        aVL,
        aVF,
        v1,
        v2,
        v3,
        v4,
        v5,
        v6,
      ];

  @override
  List<Object?> get props => toList();

  Channels range(int start, [int? end]) {
    final res = toList()
      ..map((e) {
        if (end != null && e.length < end) return <double>[];
        return e.sublist(start, end);
      }).toList();
    return Channels.fromList(res);
  }
}
