// ignore_for_file: public_member_api_docs, non_constant_identifier_names

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:equatable/equatable.dart';
import 'package:fl_chart/fl_chart.dart';

part 'plot_channels.g.dart';

@CopyWith()
class PlotChannels extends Equatable {
  const PlotChannels({
    required this.l1,
    required this.l2,
    required this.l3,
    required this.aVR,
    required this.aVL,
    required this.aVF,
    required this.v1,
    required this.v2,
    required this.v3,
    required this.v4,
    required this.v5,
    required this.v6,
    this.pivot = 0,
  });

  PlotChannels.fromList(
    List<List<FlSpot>> list,
    this.pivot,
  )   : l1 = list[0],
        l2 = list[1],
        l3 = list[2],
        aVR = list[3],
        aVL = list[4],
        aVF = list[5],
        v1 = list[6],
        v2 = list[7],
        v3 = list[8],
        v4 = list[9],
        v5 = list[10],
        v6 = list[11];

  final List<FlSpot> l1;
  final List<FlSpot> l2;
  final List<FlSpot> l3;

  final List<FlSpot> aVR;
  final List<FlSpot> aVL;
  final List<FlSpot> aVF;

  final List<FlSpot> v1;
  final List<FlSpot> v2;
  final List<FlSpot> v3;
  final List<FlSpot> v4;
  final List<FlSpot> v5;
  final List<FlSpot> v6;

  final double pivot;

  List<List<FlSpot>> toList() => [
        l1,
        l2,
        l3,
        aVR,
        aVL,
        aVF,
        v1,
        v2,
        v3,
        v4,
        v5,
        v6,
      ];

  @override
  List<Object?> get props => [
        ...toList(),
        pivot,
      ];
}
