// ignore_for_file: public_member_api_docs, always_use_package_imports, non_constant_identifier_names

import 'iir_filter.dart';

class IIRFilterClass {
  IIRFilterClass(String filterSpec) {
    if (filterSpec == IIRConstant.IIR_HPF_0_05) {
      _numer = IIRCoefficient.IIR_HPF_0_05_NUMERATOR;
      _denom = IIRCoefficient.IIR_HPF_0_05_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_HPF_0_1) {
      _numer = IIRCoefficient.IIR_HPF_0_1_NUMERATOR;
      _denom = IIRCoefficient.IIR_HPF_0_1_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_HPF_0_5) {
      _numer = IIRCoefficient.IIR_HPF_0_5_NUMERATOR;
      _denom = IIRCoefficient.IIR_HPF_0_5_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_LPF_40) {
      _numer = IIRCoefficient.IIR_LPF_40_NUMERATOR;
      _denom = IIRCoefficient.IIR_LPF_40_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_LPF_100) {
      _numer = IIRCoefficient.IIR_LPF_100_NUMERATOR;
      _denom = IIRCoefficient.IIR_LPF_100_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_BSF_50) {
      _numer = IIRCoefficient.IIR_BSF_50_NUMERATOR;
      _denom = IIRCoefficient.IIR_BSF_50_DENOMINATOR;
    } else if (filterSpec == IIRConstant.IIR_BSF_60) {
      _numer = IIRCoefficient.IIR_BSF_60_NUMERATOR;
      _denom = IIRCoefficient.IIR_BSF_60_DENOMINATOR;
    } else {
      _numer = IIRCoefficient.IIR_BSF_60_NUMERATOR;
      _denom = IIRCoefficient.IIR_BSF_60_DENOMINATOR;
    }
  }

  late List<double> _numer;
  late List<double> _denom;
  final List<double> _x_val = [0, 0, 0];
  final List<double> _y_val = [0, 0, 0];

  int _sample_cnt = 0;

  double apply(double inputVal) {
    var y1 = 0.0;
    if (_sample_cnt == 3) {
      for (var ptr = 0; ptr < 2; ptr++) {
        _x_val[ptr] = _x_val[ptr + 1];
      }
      _x_val[2] = inputVal;

      for (var ptr = 0; ptr < 3; ptr++) {
        y1 += _numer[ptr] * _x_val[2 - ptr];
      }

      for (var ptr = 1; ptr < 3; ptr++) {
        y1 -= _denom[ptr] * _y_val[2 - ptr + 1];
      }

      for (var ptr = 0; ptr < 2; ptr++) {
        _y_val[ptr] = _y_val[ptr + 1];
      }

      // _sample_cnt = 0;
      _y_val[2] = y1;

      return y1;
    } else {
      _x_val[_sample_cnt] = inputVal;

      for (var ptr = 0; ptr < _sample_cnt + 1; ptr++) {
        y1 += _numer[ptr] * _x_val[_sample_cnt - ptr];

        if (ptr > 0) {
          y1 -= _denom[ptr] * _y_val[_sample_cnt - ptr];
        }
      }

      _y_val[_sample_cnt] = y1;
      _sample_cnt += 1;

      return y1;
    }
  }
}
