import 'package:flutter_test/flutter_test.dart';
import 'package:healthrian_common_support/healthrian_common_support.dart';

void main() {
  group('WearCardioT feasible name test', () {
    test('feasible', () {
      expect('wearT:123'.isWearCardioT, true);
    });

    test('non-feasible', () {
      expect('HEH001:123'.isWearCardioT, false);
      expect('C-Click:123'.isWearCardioT, false);
    });
  });

  group('WearECG12 feasible name test', () {
    test('feasible', () {
      expect('HEH001:123'.isWearEcg12, true);
    });

    test('non-feasible', () {
      expect('wearT:123'.isWearEcg12, false);
      expect('C-Click:123'.isWearEcg12, false);
    });
  });

  group('C-CLICK feasible name test', () {
    test('feasible', () {
      expect('C-Click:123'.isCardioClick, true);
    });

    test('non-feasible', () {
      expect('HEH001:123'.isCardioClick, false);
      expect('wearT:123'.isCardioClick, false);
    });
  });

  group('stream test', () {
    test('multiple stream: broadcast', () async {
      final stream = Stream.fromIterable(Iterable<int>.generate(10));
      final broadcast = stream.broadcast;

      final res1 = <int>[];
      final res2 = <int>[];

      final subscription = broadcast.listen(res1.add);
      await for (final a in broadcast) {
        res2.add(a);
      }
      await subscription.cancel();
      expect(res1, res2);
    });
  });
}
